#include "DisplayErrorBaseClass.hpp"



DisplayErrorBaseClass::DisplayErrorBaseClass()
{
    FILE  *pFile = NULL;
    CHAR  line[500], teg[20];
    int   vlaue;

    g_debug_level = DEBUG_LEVEL_0;
    g_pass_message = PASS_MESSAGE_OFF;

    m_error_message = "";
    m_debug_message = "";

    //Open the I2C_profile.ini for parser
    #ifdef DEBUG
        pFile = fopen ("Lemur_env.ini","r");
    #else
        pFile = fopen ("/etc/lemur/Lemur_env.ini", "r");
    #endif

    if (pFile != NULL)
    {
        while (fgets(line, 500, pFile) != NULL)
        {
            if (line[0] == '#')
            {
                continue;
            }

            if ( strlen(line) == 1 && line[0] == '\n' )
            {
                continue;
            }

            sscanf(line, "%[^=]=%d", teg, &vlaue); //paser the teg:debug_level, pass_message
            if (strcmp(teg, "debug_level") == 0)
            {
                switch(vlaue)
                {
                    case 0:
                        g_debug_level = DEBUG_LEVEL_0;
                        break;
                    case 1:
                        g_debug_level = DEBUG_LEVEL_1;
                        break;
                    case 2:
                        g_debug_level = DEBUG_LEVEL_2;
                        break;
                    default:
                        break;
                }
            }
            if (strcmp(teg, "pass_message") == 0)
            {
                switch(vlaue)
                {
                    case 0:
                        g_pass_message = PASS_MESSAGE_OFF;
                        break;
                    case 1:
                        g_pass_message = PASS_MESSAGE_ON;
                        break;
                    default:
                        break;
                }
            }
        }
        fclose(pFile);
    }
    //Force "test" command show result
    if (g_command == CMD_TEST)
    {
        g_pass_message = PASS_MESSAGE_ON;
    }
}



DisplayErrorBaseClass::~DisplayErrorBaseClass()
{
	
}



void
DisplayErrorBaseClass::printError(ErrorMsg *error_code)
{
    printError(g_debug_level, error_code);
}



void
DisplayErrorBaseClass::printError(DEBUG_LEVEL debugLevel, ErrorMsg *errorCode)
{
    if (errorCode != 0)
    {
        switch (debugLevel)
        {
            case DEBUG_LEVEL_0:
                 break;
            case DEBUG_LEVEL_1:
                 getLastErrorMessage(errorCode, &m_error_message);
                cout << "Error Message: " << m_error_message << endl;
                break;
            case DEBUG_LEVEL_2:
                getErrorMessage(errorCode, &m_error_message);
                m_debug_message = m_error_message.substr(0, m_error_message.rfind(":") + 1);
                m_error_message = m_error_message.substr(m_error_message.rfind(":") + 3, m_error_message.size() - m_error_message.rfind(":") - 4);

                cout << "Debug Message: " << m_debug_message << endl;
                cout << "Error Message: " << m_error_message << endl;
                break;
            default:
                break;
        }
    }

    if (g_pass_message == PASS_MESSAGE_ON && errorCode == 0)
    {
        cout << "RESULT: PASSED" << endl;
    }
    else if (g_pass_message == PASS_MESSAGE_ON && errorCode != 0)
    {
        cout << "RESULT: FAILED" << endl;
    }

}