#ifndef DISPLAY_ERROR_BASS_CLASS_H
#define DISPLAY_ERROR_BASS_CLASS_H

#include <stdio.h>
#include <iostream>
#include <string>
#include <string.h>
#include "ErrorMsg.hpp"
#include "CommonFunctions.hpp"
#include "StringParser.hpp"

using namespace std;



enum DEBUG_LEVEL {
    DEBUG_LEVEL_0 = 0, //No Debug / Error message
    DEBUG_LEVEL_1,     //Show Error message
    DEBUG_LEVEL_2,     //Show Debug / Error message
};


enum PASS_MESSAGE {
    PASS_MESSAGE_OFF = 0, //No show Pass/Fail message in command completed
    PASS_MESSAGE_ON = 1,  //Show RESULT: PASSED or RESULT: FAILED if execute command completed
};



class DisplayErrorBaseClass
{
    public:
                        DisplayErrorBaseClass();
          virtual       ~DisplayErrorBaseClass();

                  void  printError(ErrorMsg *);
                  void  printError(DEBUG_LEVEL, ErrorMsg *);

    private:
          DEBUG_LEVEL   g_debug_level;
          PASS_MESSAGE  g_pass_message;
          string        m_error_message, m_debug_message;
};

#endif
