#ifndef MEMORY_OPERATION_H
#define MEMORY_OPERATION_H

#include <mutex>
#include "OperationBaseClass.hpp"
#include "MemoryTestInfo.hpp"

using namespace std;

class MemoryOperation: public OperationBaseClass
{
    public:
                MemoryOperation(OPERATION_TYPE, string);
        virtual ~MemoryOperation();

        int     executeECCCheck(StringParser);

        int     executeECCClear(StringParser);

        int     executeOperation(StringParser);

        int     executeShowInfo(StringParser);

        int     executeShowTestRange(StringParser);

        int     executeTestChecksum(StringParser);

        int     executeTestOnDIMM(StringParser);

        int     executeTestOnRange(StringParser);

        int     executeUtilityWrite(StringParser);

        int     executeUtilityRead(StringParser);
    private:
        int     executeTestByThreads(list<MemoryTestInfo *>);

        void    executeTestInThread(MemoryTestInfo*);

        void    handleTestProgress(list<MemoryTestInfo *>);

        int     isValidMemoryUnit(string);

        int     showECCReport(void);

        int     showMemoryContent(UINT64, UINT32, UINT64);

        void    showOperationHelp(void);

        mutex   m_mutex;
        INT32   m_s32AvailableCPUAmount;
};

#endif
