#ifndef STORAGE_OPERATION_H
#define STORAGE_OPERATION_H

#include <unistd.h>
#include <iostream>
#include <fstream>
#include <string>
#include <thread>

#include <sys/wait.h>

#include "OperationBaseClass.hpp"
#include "StorageDAPI.hpp"

#define MAX_CURRENT_RUNNING_DRIVE_AMOUNT 512

using namespace std;

class StorageOperation: public OperationBaseClass
{
public:
     StorageOperation(OPERATION_TYPE, string);
     virtual  ~StorageOperation();

     //Decide which operation to be executed
     INT32 executeOperation(StringParser);

     //List Storage device node
     INT32 executeList(StringParser);

     //Show Storage device characteristics
     INT32 executeShow(StringParser);

     //Execute test command
     INT32 executeTest(StringParser);

     //Execute test command
//     INT32 executeError(StringParser);

     //Execute test command
     INT32 executeUtility(StringParser);

     //Show parameter message here
     INT32 helpParameter();

     //Check parameter syntax here
     INT32 checkSyntax(StringParser);
                
private:
     OPERATION_TYPE m_OperationType;
     StorageDAPI    *m_pStorageDAPI;
     thread         *m_pProgressHandler[MAX_CURRENT_RUNNING_DRIVE_AMOUNT];
     void handleTestProgress(UINT32 in_u32TestSizeMB);
     string convertStringToUpperCase(string in_strInputString);
};

#endif
