#include "TPMCommand.hpp"

TPMCommand::TPMCommand(COMMAND_TYPE eCommandType, string strHelpContent) : CommandBaseClass(eCommandType, strHelpContent)
{
    m_pTPMDAPI = NULL;
    m_s32Result = 0; //default to no error

    switch(eCommandType)
    {
        case CMD_SHOW:
            addOperation(new TPMOperation(OPERATION_ALL, "Show all information"));
            addOperation(new TPMOperation(OPERATION_FW, "Show firmware version"));
            addOperation(new TPMOperation(OPERATION_VENDOR, "Show vendor information"));
            addOperation(new TPMOperation(OPERATION_CHIP, "Show chip name"));
            addOperation(new TPMOperation(OPERATION_STATUS, "Show status"));
            addOperation(new TPMOperation(OPERATION_FAMILY, "Show TPM family"));
            break;
        case CMD_TEST:
            addOperation(new TPMOperation(OPERATION_SELFTEST, "Perform selftest"));
            break;
        case CMD_UTILITY:
            addOperation(new TPMOperation(OPERATION_CMD, "send TPM command manually"));
            break;
        default:
            break;
    }
}


TPMCommand::~TPMCommand()
{

}

int
TPMCommand::List()
{
    m_pTPMDAPI = new TPMDAPI("TPMDAPI");

    m_pTPMDAPI->displayDevice();

    delete m_pTPMDAPI;
    m_pTPMDAPI = NULL;

    return 0;
}

int
TPMCommand::executeCommand(StringParser in_classCommandLine)
{
    //int             s32Index;
    //string          strTemp;
    //string          strOperationName;
    COMMAND_TYPE    eCommandType = NO_COMMAND;


    in_classCommandLine.getCommandType(&eCommandType);
    switch (eCommandType)
    {
        case CMD_LIST:
            return List();

        case CMD_SHOW:
        case CMD_TEST:
        case CMD_UTILITY:
            return findAndExecuteOperation(in_classCommandLine);

        default:
            cout << UNKNOWN_COMMAND_MSG << endl;
            return -1;
    }
/*
    in_classCommandLine.getOperation(&strOperationName);
    if(strOperationName == "help" || strOperationName == "")
    {
        listOperation(in_classCommandLine);
        return -1;
    }

    for(s32Index = 0; s32Index < m_operation_count; s32Index++)
    {
        m_operation[s32Index]->getName(&strTemp);
        if(strTemp == strOperationName)
        {
            return m_operation[s32Index]->executeOperation(in_classCommandLine);
        }
    }

    cout << strOperationName << " operation is not found" << endl;
    listOperation(in_classCommandLine);
    return -1;
*/
}
