#ifndef UARTOperation_H
#define UARTOperation_H

#include "OperationBaseClass.hpp"
#include "UARTDAPI.hpp"

#define UART_DEBUG_LEVEL DEBUG_LEVEL_1
//#define UART_DEBUG_LEVEL DEBUG_LEVEL_2 //debug mode

class UARTOperation : public OperationBaseClass
{
    public:
                 UARTOperation(OPERATION_TYPE, string);
        virtual ~UARTOperation();

        int executeOperation(StringParser command_line);

    private:
        UARTDAPI*       m_pUartDAPI;
        int             m_s32Result;
        ErrorMsg*       m_pErrorMsg;
        string          m_strParameter[PARAMETER_NUMBER];
        char            m_uartName[16];


        void    showHelp();
        int     checkSyntax(StringParser);
        int     showUartInfo();
        int     showIndividualItem(SERIAL_INFO, OPERATION_TYPE);

        int     testScratchPad();
        int     doInternalLoopbackTest();

};

#endif
