/*
 ******************************************************************************
 * diag_ioctl.h - Provides Miscellaneous functions
 *
 * Copyright (C) LSI LOGIC, Inc.  2011
 *
 ******************************************************************************
 */
#ifndef SASDIAG_IOCTL_INCLUDED
#define SASDIAG_IOCTL_INCLUDED
#include "sasdiag.h"


#define SASDIAG_BASE_IOCTL   40

/**
 * IOCTL opcodes
 */
#define SASDIAG_PRINT _IOW(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL, \
    print_ctrl)

#define SASDIAG_GPIO_LED_CONTROL _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 1, \
    gpio_ctrl)

#define SASDIAG_IOC_CONTROL _IOW(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 2, \
    ioc_ctrl)

#define SASDIAG_CFG_CONTROL _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 3, \
    cfg_ctrl)

#define SASDIAG_PORT_PHY_CONTROL _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 4, \
    port_phy_ctrl)

#define SASDIAG_REGISTER_CONTROL _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 5, \
    reg_ctrl)

#define SASDIAG_EXEC _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 6, \
    exec_ctrl)
				
#define SASDIAG_STATUS_CHECK _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 7, \
    check_status)

#define SASDIAG_GET_INFO _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 8, \
    get_info)

#define SASDIAG_GET_INFO_LIST _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 9, \
    get_info_list)

#define SASDIAG_EXEC_LOOPBACK _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 10, \
    sas_loopback_param)	
 
#define SASDIAG_FPGA_CONTROL _IOWR(MPT3_MAGIC_NUMBER, SASDIAG_BASE_IOCTL + 11, \
    fpga_ctrl)

#endif // include
