#include "GetMCEDAPI.hpp"


GetMCEDAPI:: GetMCEDAPI(STRING className) : BaseClassDAPI(className)
{

}


GetMCEDAPI:: ~GetMCEDAPI()
{

}



void GetMCEDAPI:: mce_prepare(struct mce *m)
{
    if (!m->time)
        m->time = time(NULL);
}



void GetMCEDAPI:: dump_mce_raw_ascii(struct mce *m, unsigned recordlen, string *Test_result)
{
    char buffer[50];

    if (!m->finished)
    {
        Test_result->append("not finished?\n");
        //printf("not finished?\n");
    }
    sprintf(buffer, "\nCPU %u\n", m->extcpu ? m->extcpu : m->cpu);
    Test_result->append(buffer);
    sprintf(buffer, "BANK %d\n", m->bank);
    Test_result->append(buffer);
    sprintf(buffer, "TSC %#llx\n", m->tsc);
    Test_result->append(buffer);
    sprintf(buffer, "RIP %#02x:%#llx\n", m->cs, m->ip);
    Test_result->append(buffer);
    sprintf(buffer, "MISC %#llx\n", m->misc);
    Test_result->append(buffer);
    sprintf(buffer, "ADDR %#llx\n", m->addr);
    Test_result->append(buffer);
    sprintf(buffer, "STATUS %#llx\n", m->status);
    Test_result->append(buffer);
    sprintf(buffer, "MCGSTATUS %#llx\n", m->mcgstatus);
    Test_result->append(buffer);
    //printf("CPU %u\n", m->extcpu ? m->extcpu : m->cpu);
    //printf("BANK %d\n", m->bank);
    //printf("TSC %#llx\n", m->tsc);
    //printf("RIP %#02x:%#llx\n", m->cs, m->ip);
    //printf("MISC %#llx\n", m->misc);
    //printf("ADDR %#llx\n", m->addr);
    //printf("STATUS %#llx\n", m->status);
    //printf("MCGSTATUS %#llx\n", m->mcgstatus);
    if (m->time) {
        time_t t = m->time;
        sprintf(buffer, "TIME %llu, %s", m->time, ctime(&t));
        Test_result->append(buffer);
        //printf("TIME %llu, %s", m->time, ctime(&t));
    }
#define CPRINT(str, field)                              \
        if (recordlen >= offsetof(struct mce, field))   \
        sprintf(buffer, str, m->field);                  \
        Test_result->append(buffer);
        //printf(str "\n", m->field)
        CPRINT("SOCKETID %u\n", socketid);
        CPRINT("APICID %u\n", apicid);
        CPRINT("MCGCAP %#llx\n", mcgcap);
#undef CPRINT
        //Test_result->append("\n");
        //printf("\n");
}



void GetMCEDAPI:: dump_mce_raw_ascii(struct mce *m, unsigned recordlen, string *MCE_message, int CPU_socketID)
{
    char buffer[50];

    if (m->socketid == CPU_socketID)
    {
        if (!m->finished)
        {
            MCE_message->append("not finished?\n");
            //printf("not finished?\n");
        }
        sprintf(buffer, "CPU %u\n", m->extcpu ? m->extcpu : m->cpu);
        MCE_message->append(buffer);
        sprintf(buffer, "BANK %d\n", m->bank);
        MCE_message->append(buffer);
        sprintf(buffer, "TSC %#llx\n", m->tsc);
        MCE_message->append(buffer);
        sprintf(buffer, "RIP %#02x:%#llx\n", m->cs, m->ip);
        MCE_message->append(buffer);
        sprintf(buffer, "MISC %#llx\n", m->misc);
        MCE_message->append(buffer);
        sprintf(buffer, "ADDR %#llx\n", m->addr);
        MCE_message->append(buffer);
        sprintf(buffer, "STATUS %#llx\n", m->status);
        MCE_message->append(buffer);
        sprintf(buffer, "MCGSTATUS %#llx\n", m->mcgstatus);
        MCE_message->append(buffer);
        sprintf(buffer, "SOCKETID %d\n", m->socketid);
        MCE_message->append(buffer);
        sprintf(buffer, "APICID %d\n", m->apicid);
        MCE_message->append(buffer);
        sprintf(buffer, "MCGCAP 0x%llx\n", m->mcgcap);
        MCE_message->append(buffer);
        //printf("CPU %u\n", m->extcpu ? m->extcpu : m->cpu);
        //printf("BANK %d\n", m->bank);
        //printf("TSC %#llx\n", m->tsc);
        //printf("RIP %#02x:%#llx\n", m->cs, m->ip);
        //printf("MISC %#llx\n", m->misc);
        //printf("ADDR %#llx\n", m->addr);
        //printf("STATUS %#llx\n", m->status);
        //printf("MCGSTATUS %#llx\n", m->mcgstatus);
        //printf("SOCKETID %d\n", m->socketid");
        //printf("APICID %d\n", m->apicid");
        //printf("MCGCAP 0x%llx\n", m->mcgcap);
        if (m->time) {
            time_t t = m->time;
            sprintf(buffer, "TIME %llu, %s\n", m->time, ctime(&t));
            MCE_message->append(buffer);
            //printf("TIME %llu, %s\n", m->time, ctime(&t));
        }
    }
}



ErrorMsg*
GetMCEDAPI:: process(int fd, unsigned recordlen, unsigned loglen, char *buf, string *Test_result)
{
    int i;
    int len;

    if (recordlen == 0) {
        Test_result->append("No MCE error message.");
        //printf("No MCE error message.\n");
        return NO_ERROR_MSG;
    }

    len = read(fd, buf, recordlen * loglen);
    if (len < 0) {
        Test_result->append("mcelog read");
        //printf("mcelog read\n");
        return NO_ERROR_MSG;
    }
    else if (!len){
        Test_result->append("No MCE error message.");
        //printf("No MCE error message.\n");
        //ret = 0;
        return NO_ERROR_MSG;
    }

    for (i = 0; i < len / (int)recordlen; i++) {
        //ret = 1;
        struct mce *mce = (struct mce *)(buf + i*recordlen);
        mce_prepare(mce);

        //Test_result->append("MCE %d\n", i);
        //printf("MCE %d\n", i);
        dump_mce_raw_ascii(mce, recordlen, Test_result);

        fflush(stdout);
    }

    if (recordlen > sizeof(struct mce)) {
        //printf("warning: %lu bytes ignored in each record\n",
        //      (unsigned long)recordlen - sizeof(struct mce));
        //printf("consider an update\n");
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_PROCESS | ERROR_PROCESSOR_DAPI_GET_MCE_PROCESS_FAIL), NULL, NULL);
    }

    return NO_ERROR_MSG;
}



ErrorMsg*
GetMCEDAPI:: process(int fd, unsigned recordlen, unsigned loglen, char *buf, string *MCE_message, int CPU_socketID)
{
    int i;
    int len;

    if (recordlen == 0)
    {
        MCE_message->append("No MCE error message.");
        //printf("No MCE error message.\n");
        return NO_ERROR_MSG;
    }

    len = read(fd, buf, recordlen * loglen);
    if (len < 0)
    {
        MCE_message->append("mcelog read");
        //printf("mcelog read\n");
        return NO_ERROR_MSG;
    }
    else if (!len)
    {
        MCE_message->append("No MCE error message.");
        //printf("No MCE error message.\n");
        //ret = 0;
        return NO_ERROR_MSG;
    }

    for (i = 0; i < len / (int)recordlen; i++)
    {
        //ret = 1;
        struct mce *mce = (struct mce *)(buf + i*recordlen);
        mce_prepare(mce);

        //MCE_message->append("MCE %d\n", i);
        //printf("MCE %d\n", i);
        dump_mce_raw_ascii(mce, recordlen, MCE_message, CPU_socketID);

        fflush(stdout);
    }

    //Erase carriage return character
    MCE_message->erase(MCE_message->length() - 2, string::npos);

    if (recordlen > sizeof(struct mce))
    {
        //printf("warning: %lu bytes ignored in each record\n",
        //      (unsigned long)recordlen - sizeof(struct mce));
        //printf("consider an update\n");
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_PROCESS | ERROR_PROCESSOR_DAPI_GET_MCE_PROCESS_FAIL), NULL, NULL);
    }

    return NO_ERROR_MSG;
}



ErrorMsg* GetMCEDAPI::Execute(string *Test_result)
{
    fd = open("/dev/mcelog", O_RDONLY);
    if (fd < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_OPEN_MCE_NODE_FAIL), NULL, NULL);
    }

    if (ioctl(fd, MCE_GET_RECORD_LEN, &d.recordlen) < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_MCE_GET_RECORD_LEN), NULL, NULL);
    }
    if (ioctl(fd, MCE_GET_LOG_LEN, &d.loglen) < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_MCE_GET_LOG_LEN), NULL, NULL);
    }

    d.buf = (char*)calloc(1, d.recordlen * d.loglen);
    process(fd, d.recordlen, d.loglen, d.buf, Test_result);

    delete d.buf;
    close(fd);

    return NO_ERROR_MSG;
}



ErrorMsg*  GetMCEDAPI::Execute(int CPU_socketID, string *MCE_message)
{
    fd = open("/dev/mcelog", O_RDONLY);
    if (fd < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_OPEN_MCE_NODE_FAIL), NULL, NULL);
    }

    if (ioctl(fd, MCE_GET_RECORD_LEN, &d.recordlen) < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_MCE_GET_RECORD_LEN), NULL, NULL);
    }
    if (ioctl(fd, MCE_GET_LOG_LEN, &d.loglen) < 0)
    {
        return returnErrorMsg((ERRORCODE)(ERROR_PROCESSOR_DAPI_GET_MCE_EXECUTE | ERROR_PROCESSOR_DAPI_MCE_GET_LOG_LEN), NULL, NULL);
    }

    d.buf = (char*)calloc(1, d.recordlen * d.loglen);
    process(fd, d.recordlen, d.loglen, d.buf, MCE_message, CPU_socketID);

    delete d.buf;
    close(fd);

    return NO_ERROR_MSG;
}
