#include "I2CDAPI.hpp"

I2CDAPI :: I2CDAPI(STRING className) : BaseClassDAPI(className)
{
    /*m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        addErrorMsg(ERROR_I2C_DAPI_CONSTRUCTOR, NULL, m_errorCode);
    }
    if (m_i2c_driver == NULL)
    {
        addErrorMsg( (ERRORCODE)(ERROR_I2C_DAPI_CONSTRUCTOR | ERROR_DIAGNOSTIC_API_CONSTRUCTOR1_ERROR), "Create I2C_DDAPI fail");
    }*/
   
}



I2CDAPI :: ~I2CDAPI()
{
    if (m_i2c_driver != NULL)
        delete m_i2c_driver;
}



ErrorMsg * I2CDAPI :: DisplayI2cDevicesList(list<string> *i2c_list)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST, NULL, m_errorCode);
    }

    m_errorCode = m_i2c_driver->get_i2c_devices_list(i2c_list);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: Read(string well_know_name, int StartRegister, int EndRegister, int *data, int *count)
{
    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, NULL, m_errorCode);
    }

    m_errorCode = m_i2c_driver->read(well_know_name, StartRegister, EndRegister, data, count);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Read(string well_know_name, int StartRegister, int EndRegister, UINT8 *data, int *count)
{
    int j;
    int data_buffer[8192];

    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By well_know_name", m_errorCode);
    }

    m_errorCode = m_i2c_driver->read(well_know_name, StartRegister, EndRegister, data_buffer, count);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By well_know_name", m_errorCode);
    }

    for(j=0; j<*count ; j++)
    {
        data[j] = (UINT8)data_buffer[j];
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Read(string well_know_name, int StartRegister, int EndRegister, UINT16 *data, int *count)
{
//    int index, j, data_buffer_count = 0;
    int data_buffer[1024], i;

    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By well_know_name", m_errorCode);
    }

//    for (index = StartRegister; index<=EndRegister ; index += data_buffer_count)
//    {
        m_errorCode = m_i2c_driver->read(well_know_name, StartRegister, EndRegister, data_buffer, count);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_READ, "By well_know_name", m_errorCode);
        }

        for (i = 0; i < *count; i++)
        {
            data[i] = data_buffer[i];
        }
//        if (data_buffer_count == 1)
//        {
//           data[*count] =  (data_buffer[0] << 8) |  data_buffer[0];
//           *count += data_buffer_count;
//        }
//        else if (data_buffer_count == 2)
//        {
//            data[*count] = (data_buffer[1] << 8)| data_buffer[0];
//            *count += 1;
//        }
//        else
//        {
//            for(j=0; j<data_buffer_count; j = j + 2)
//            {
//                data[*count + (j/2)] = (data_buffer[j+1] << 8) | data_buffer[j];
//            }
//            *count += data_buffer_count / 2;
//        }
//    }

    return NO_ERROR_MSG;
}


ErrorMsg * I2CDAPI :: Read(int bus, int deviceAddress, int StartRegister, int EndRegister, int *data, int *count)
{
//    int index, j, data_buffer_count = 0;
//    int data_buffer[100];

    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
    }

//    for (index = StartRegister; index<=EndRegister ; index += data_buffer_count)
//    {
        m_errorCode = m_i2c_driver->read(bus, deviceAddress, StartRegister, EndRegister, data, count);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
        }

//        for(j=0; j<data_buffer_count ; j++)
//        {
//            data[*count + j] = data_buffer[j];
//        }
//        *count = data_buffer_count;
//    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Read(int bus, int deviceAddress, int StartRegister, int EndRegister, UINT8 *data, int *count)
{
//    int index, j, data_buffer_count = 0;
    int data_buffer[100];

    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
    }

//    for (index = StartRegister; index<=EndRegister ; index += data_buffer_count)
//    {
        m_errorCode = m_i2c_driver->read(bus, deviceAddress, StartRegister, EndRegister, data_buffer, count);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
        }

//        for(j=0; j<data_buffer_count ; j++)
//        {
//            data[*count + j] = (UINT8)data_buffer[j];
//        }
//        *count += data_buffer_count;
//    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Read(int bus, int deviceAddress, int StartRegister, int EndRegister, UINT16 *data, int *count)
{
//    int index, j, data_buffer_count = 0;
    int data_buffer[100];

    *count = 0;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
    }

//    for (index = StartRegister; index<=EndRegister ; index += data_buffer_count)
//    {
        m_errorCode = m_i2c_driver->read(bus, deviceAddress, StartRegister, EndRegister, data_buffer, count);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_READ, "By bus_address", m_errorCode);
        }

//        for(j=0; j<data_buffer_count ; j = j+2)
//        {
//            data[*count + (j/2)] = (data_buffer[j+1] << 8)| data_buffer[j];
//        }
//        *count += data_buffer_count / 2;
//    }

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: Write(string well_know_name, int StartRegister, int *data, int count)
{
/*    int index, j, data_buffer_count = 0;
    int data_buffer[100];

    *count = 0;

    for (index = StartRegister; index<=EndRegister ; index += data_buffer_count)
    {*/

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

        m_errorCode = m_i2c_driver->write(well_know_name, StartRegister, data, count);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
        }

/*        for(j=0; j<data_buffer_count ; j++)
        {
            data[*count + j] = data_buffer[j];
        }
        *count += data_buffer_count;
    }*/

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(string well_know_name, int StartRegister, int *data, int count, int *numberRealWrite)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

        m_errorCode = m_i2c_driver->write(well_know_name, StartRegister, data, count, numberRealWrite);
        if(m_errorCode != NO_ERROR_MSG)
        {
            return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
        }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(string well_know_name, int StartRegister, UINT8 *data, int count)
{
    int data_buffer[8192], i;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

    for (i = 0; i < count ; i++)
    {
        data_buffer[i] = data[i];
    }

    m_errorCode = m_i2c_driver->write(well_know_name, StartRegister, data_buffer, count);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(string well_know_name, int StartRegister, UINT16 *data, int count)
{
    int data_buffer[8192], i;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

    for (i=0; i<count ; i++)
    {
        //data_buffer[(i*2)+1] = data[i] >> 8;
        //data_buffer[i*2] = data[i] & 0x00ff;
        data_buffer[i*2] = data[i] >> 8;
        data_buffer[(i*2)+1] = data[i] & 0x00ff;
    }


    m_errorCode = m_i2c_driver->write(well_know_name, StartRegister, data_buffer, count * 2);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By well_know_name", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: Write(int bus, int deviceAddress, int StartRegister, int *data, int count)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    m_errorCode = m_i2c_driver->write(bus, deviceAddress, StartRegister, data, count);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(int bus, int deviceAddress, int StartRegister, int *data, int count, int *numberRealWrite)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    m_errorCode = m_i2c_driver->write(bus, deviceAddress, StartRegister, data, count, numberRealWrite);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(int bus, int deviceAddress, int StartRegister, UINT8 *data, int count)
{
    int data_buffer[8192], i;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    for (i = 0; i < count; i++)
    {
        data_buffer[i] = data[i];
    }

    m_errorCode = m_i2c_driver->write(bus, deviceAddress, StartRegister, data_buffer, count);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: Write(int bus, int deviceAddress, int StartRegister, UINT16 *data, int count)
{
    int data_buffer[8192], i;
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    for (i=0; i<count ; i++)
    {
        data_buffer[(i*2)+1] = data[i] >> 8;
        data_buffer[i*2] = data[i] & 0x00ff;
    }

    m_errorCode = m_i2c_driver->write(bus, deviceAddress, StartRegister, data_buffer, count * 2);
    if(m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_WRITE, "By bus_address", m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: DisplayI2cDevicesListByType(I2CDevice *i2c_list[], I2C_DEVICE_TYPE ptype)
{
    int             i, j, count;
    int             bus, address;
    string          name, vender, model;
    I2C_DEVICE_TYPE type;
    I2CDevice       *my_i2c_list[DEVICE_NUMBER];

    int       switch_output[32], switch_output_counter;
    I2CSwitch *p_switch;

    //Initial device/bus table
    for (i=0; i<DEVICE_NUMBER; i++)
    {
        my_i2c_list[i] = NULL;
        i2c_list[i] = NULL;
    }

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST_BY_TYPE, NULL, m_errorCode);
    }


    m_errorCode = m_i2c_driver->get_i2c_devices_list(my_i2c_list);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST_BY_TYPE, NULL, m_errorCode);
    }

    count = 0;

    for (i=0; my_i2c_list[i]; i++)
    {
        if (my_i2c_list[i]->get_type() == ptype)
        {
           //printf("%s\n",i2c_list[i]->get_Name());
           name = my_i2c_list[i]->get_Name();
           bus = my_i2c_list[i]->get_Bus();
           address = my_i2c_list[i]->get_Address();
           type = my_i2c_list[i]->get_type();
           vender = my_i2c_list[i]->get_vender();
           model = my_i2c_list[i]->get_model();
           //printf("name:%s bus:%x add.:%x type:%d vender:%s model:%s\n",name.c_str(), bus, address, type, vender.c_str(), model.c_str());
           if (type != MUX)
           {
              i2c_list[count] = new I2CDevice(name, bus, address, type, vender, model);
           }
           else
           {
              p_switch = (I2CSwitch *)my_i2c_list[i];
              switch_output_counter = p_switch->get_output_port_counter();
              for (j=0; j<switch_output_counter; j++)
                 switch_output[j] = p_switch->get_output_port(j);
              i2c_list[count] = new I2CSwitch(name, bus, address, switch_output,  switch_output_counter, type, vender, model);
           }
           count++;
        }
    }

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: DisplayI2cDevicesList(I2CDevice *i2c_list[], int *count)
{
    int             i, j, m_count;
    int             bus, address;
    string          name, vender, model;
    I2C_DEVICE_TYPE type;
    I2CDevice       *my_i2c_list[DEVICE_NUMBER];

    int       switch_output[32], switch_output_counter;
    I2CSwitch *p_switch;

    //Initial device/bus table
    for (i=0; i<DEVICE_NUMBER; i++)
    {
        my_i2c_list[i] = NULL;
        i2c_list[i] = NULL;
    }

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST_BY_TYPE, NULL, m_errorCode);
    }


    m_errorCode = m_i2c_driver->get_i2c_devices_list(my_i2c_list);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_DISPLAY_I2C_DEVICES_LIST_BY_TYPE, NULL, m_errorCode);
    }

    m_count = 0;

    for (i=0; my_i2c_list[i]; i++)
    {
        //printf("%s\n",i2c_list[i]->get_Name());
        name = my_i2c_list[i]->get_Name();
        bus = my_i2c_list[i]->get_Bus();
        address = my_i2c_list[i]->get_Address();
        type = my_i2c_list[i]->get_type();
        vender = my_i2c_list[i]->get_vender();
        model = my_i2c_list[i]->get_model();
        //printf("name:%s bus:%x add.:%x type:%d vender:%s model:%s\n",name.c_str(), bus, address, type, vender.c_str(), model.c_str());
        if (type != MUX)
        {
           i2c_list[m_count] = new I2CDevice(name, bus, address, type, vender, model);
        }
        else
        {
           p_switch = (I2CSwitch *)my_i2c_list[i];
           switch_output_counter = p_switch->get_output_port_counter();
           for (j=0; j<switch_output_counter; j++)
              switch_output[j] = p_switch->get_output_port(j);
           i2c_list[m_count] = new I2CSwitch(name, bus, address, switch_output,  switch_output_counter, type, vender, model);
        }
        m_count++;
    }
    *count = m_count;

    return NO_ERROR_MSG;
}



ErrorMsg * I2CDAPI :: MUX_Test(string well_know_name)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "MUX test", m_errorCode);
    }

    m_errorCode = m_i2c_driver->mux_test(well_know_name);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: StuckPrevention(int busID)
{
    //TBD FPGA I2C master controller

    m_errorCode = NO_ERROR_MSG;

    m_i2c_driver = new I2CDDAPI("I2C_drv");
    m_errorCode =  m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        delete m_i2c_driver;
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "MUX test", m_errorCode);
    }

    m_errorCode = m_i2c_driver->stuckPrevention(busID);

    delete m_i2c_driver;

    return m_errorCode;
}



ErrorMsg  * I2CDAPI :: WriteReadTest(string well_know_name)
{
    int original_data_buffer[256], count, data_buffer[256];
    int test_pattern[256], index;

    m_i2c_driver = new I2CDDAPI("I2C_drv");

    m_errorCode = m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "MUX test", m_errorCode);
    }

    //Store the original data
    m_errorCode = m_i2c_driver->read(well_know_name, 0x00, 0xFF, original_data_buffer, &count);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    //Debug message
    //printf("Orignal data:\n");
    //DisplayBufferContent(original_data_buffer, count);
    //printf("\n");

    //Start write first pattern
    for (index = 0; index < 256; index++)
    {
        test_pattern[index] = 0XAA;
    }

    m_errorCode = m_i2c_driver->write(well_know_name, 0x00, test_pattern, count);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    //Read out and compare
    m_errorCode = m_i2c_driver->read(well_know_name, 0x00, 0xFF, data_buffer, &count);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    //Debug message
    //printf("Write data: 0x%x\n", test_pattern[0]);
    //DisplayBufferContent(data_buffer, count);
    //printf("\n");

    //Compare
    for (index = 0; index < count; index++)
    {
        if (0xAA != data_buffer[index])
        {
            printf("Expect: 0x%x, get 0x%x value: %x, compare fail!\n",  test_pattern[index], index, data_buffer[index]);

            //Restore original value
            m_errorCode = m_i2c_driver->write(well_know_name, 0x00, original_data_buffer, count);
            return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
        }
    }

    //Start write second pattern
    for (index = 0; index < 256; index++)
    {
        test_pattern[index] = 0X55;
    }

    m_errorCode = m_i2c_driver->write(well_know_name, 0x00, test_pattern, count);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }
    //Read out and compare
    m_errorCode = m_i2c_driver->read(well_know_name, 0x00, 0xFF, data_buffer, &count);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    //Debug message
    //printf("Write data: 0x%x\n", test_pattern[0]);
    //DisplayBufferContent(data_buffer, count);
    //printf("\n");

    //Compare
    for (index = 0; index < count; index++)
    {
        if (0x55 != data_buffer[index])
        {
            printf("Expect: 0x%x, get value: %x, compare fail!\n",  test_pattern[index], data_buffer[index]);

            //Restore original value
            m_errorCode = m_i2c_driver->write(well_know_name, 0x00, original_data_buffer, count);
            return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
        }
    }


    //Restore original value
    m_errorCode = m_i2c_driver->write(well_know_name, 0x00, original_data_buffer, count);

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: DisplayBufferContent(int *buffer, int count)
{
    int index;

    for (index = 0; index < count; index++)
    {
        if (index == 0 || (index % 16) == 0 )
        {
            printf("%04x: ", index);
        }
        printf("%02x ", buffer[index]);
        if (((index + 1) % 16) == 0  && index != (count - 1))
        {
            printf("\n");
        }
    }
    printf("\n");

    return NO_ERROR_MSG;
}



ErrorMsg  * I2CDAPI :: ShowRoutePath(string well_know_name, string *path)
{
    m_i2c_driver = new I2CDDAPI("I2C_drv");

    m_errorCode = m_i2c_driver->getErrorMsg();
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, "Route path test", m_errorCode);
    }

    //Get the device path data
    m_errorCode = m_i2c_driver->get_i2c_device_path(well_know_name, path);
    if (m_errorCode != NO_ERROR_MSG)
    {
        return returnErrorMsg(ERROR_I2C_DAPI_MUX_TEST, NULL, m_errorCode);
    }

    return NO_ERROR_MSG;
}


