#ifndef USB_DAPI_H
#define USB_DAPI_H

#include "BaseClassDAPI.hpp"
#include "USBDDAPI.hpp"
#include "MemoryDAPI.hpp"




class USBDAPI : public BaseClassDAPI
{
    public: 
                         USBDAPI(STRING className);
            virtual      ~USBDAPI(void);
            ErrorMsg*   displayUSBDevicesList(list<string> *pUSBList);
            ErrorMsg*   getIndexByName(STRING WellKnownName, UINT32 *LogicalID);




            ErrorMsg*   getElementByIndex(UINT32 Index,
                                    USB_DATA_ELEMENT USBDataElement,
                                    list<string> *returnDataInfo);



            //Read/Write Performance
            ErrorMsg*   readNwriteTest(UINT32 Index,
                                      list<string> *returnDataInfo,
                                      UINT32 StartSector,
                                      UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                      UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readNwriteTestSetup(UINT32   LogicalID,
                                           UINT32   LogicalSector,
                                           UINT32   TestSize = DEFAULT_USB_TEST_SIZE,
                                           UINT32   BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readNwriteTestExecute(UINT32   Index,
                                             list<string> *returnDataInfo,
                                             UINT32   LogicalSector,
                                             UINT32   TestSize = DEFAULT_USB_TEST_SIZE,
                                             UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readNwriteTestCleanup(UINT32 LogicalID);


            //Read Performance
            ErrorMsg*   readPFMCTest(UINT32  Index,
                                            list<string> *returnDataInfo,
                                            UINT32  StartSector,
                                            UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                            UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPFMCTestSetup(UINT32 Index,
                                                 UINT32 LogicalSector,
                                                 UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                 UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPFMCTestExecute(UINT32   Index,
                                                   list<string> *returnDataInfo,
                                                   UINT32   LogicalSector,
                                                   UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                   UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   readPFMCTestCleanup(UINT32 Index);


            //Write Performance
            ErrorMsg*   writePFMCTest(UINT32 Index,
                                             list<string> *returnDataInfo,
                                             UINT32 StartSector,
                                             UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                             UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePFMCTestSetup(UINT32   Index,
                                                  UINT32   LogicalSector,
                                                  UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                  UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePFMCTestExecute(UINT32   Index,
                                                    list<string> *returnDataInfo,
                                                    UINT32   LogicalSector,
                                                    UINT32 TestSize = DEFAULT_USB_TEST_SIZE,
                                                    UINT32  BlockSize = DEFAULT_USB_BLOCK_SIZE);
            ErrorMsg*   writePFMCTestCleanup(UINT32 Index);
    private:
            USBDDAPI    *m_USBDiver;
            MemoryDAPI  *m_pMemoryDAPI;
            UINT32      *m_pDataBuffer;

            //FILE*       m_pFileHandle;
            INT32      m_pFileHandle;

            ErrorMsg    *m_errorCode;

            ErrorMsg*   openDeviceFile(STRING intFileNode);
            ErrorMsg*   closeDeviceFile(UINT32 in_pFileNode);
            //ErrorMsg*   SetFileDescription(INT32 fileDescription);






};

#endif
