/// @file       BaseClassDDAPI.hpp
/// @brief      BaseClassDDAPI class
/// @details    Provide DDAPI base class for all modules
/// @copyright  Copyright 2014 Hon Hai Technology Group. All Rights Reserved.

#ifndef BASE_CLASS_DDAPI_HPP
#define BASE_CLASS_DDAPI_HPP

#include <string>
#include <list>
#include "BaseClassAPI.hpp"

using::std::string;
using::std::list;

/// @class      BaseClassDDAPI BaseClassDDAPI.hpp "BaseClassDDAPI.hpp"
/// @brief      Provide DDAPI common functions for all modules
class BaseClassDDAPI : public BaseClassAPI
{
    public:
                            BaseClassDDAPI(STRING in_szClassName);
        virtual             ~BaseClassDDAPI(void);

        virtual ErrorMsg*   getLEDList(list<string> *out_pLEDList);
        virtual ErrorMsg*   getLEDStatus(string in_strLEDName,
                                         string *out_strpStatus);

        virtual ErrorMsg*   setLEDStatus(string   in_strLEDName,
                                         string   in_strStatus);

    protected:

    private:

};


#endif

