#ifndef EthernetBaseClass_H
#define EthernetBaseClass_H

#include "BaseClassDDAPI.hpp"
#include <linux/ethtool.h>

#include <sys/ioctl.h>
#include <net/if.h>
#include <linux/sockios.h>
#include <unistd.h>
#include <fstream>

enum TestType
{
    EepromValidation,
    Register,
    Interrupt,
    InternalLoopback,
    LinkStatus
};


class EthernetBaseClass : public BaseClassDDAPI
{
    public:
                          EthernetBaseClass(STRING nic_name);
                         ~EthernetBaseClass();
        virtual  ErrorMsg* Set_external_loopback();
        virtual  ErrorMsg* Remove_external_loopback();
        virtual  ErrorMsg* Get_self_test_result(struct ethtool_test *test, TestType index, INT32 *test_result);
        virtual  ErrorMsg* SetupSpeed(string ethernet_name, INT32 speed);
        virtual  ErrorMsg* GetMAC(string ethernet_name, string *mac_address);
        virtual  ErrorMsg* SetMAC(string ethernet_name, string *mac_address);
        virtual  ErrorMsg* GetEEPROM(string ethernet_name, INT32 StartAddress, INT32 Length, INT32 *data);
        virtual  ErrorMsg* SetEEPROM(string ethernet_name, INT32 StartAddress, INT32 *data, INT32 Length);
        virtual  ErrorMsg* Program(string ethernet_name, string filePath);
        virtual  ErrorMsg* ReadSFP(string ethernet_name, INT32 DeviceAddress, INT32 StartAddress, INT32 Length, INT32 *data);
        virtual  ErrorMsg* WriteSFP(string ethernet_name, INT32 DeviceAddress, INT32 StartAddress, INT32 data);
        virtual  ErrorMsg* getLEDName(string nic, list<string> *LED);
        virtual  ErrorMsg* setLEDStatus(string ethernet_name, string in_strLEDName, string in_strStatus);
        virtual  ErrorMsg* getLEDStatus(string ethernet_name, string in_strLEDName, string *out_strpStatus);
                 ErrorMsg* GetLinkStatus(string nic, string *status_result);
                 ErrorMsg* GetPCIFunction(string nic, int *function_id);
                 ErrorMsg* GetPCIBusDeviceFunction(string ethernet_name, int *domain, int *bus, int *device, int *func);
                 ErrorMsg* GetPCIDeviceID(string ethernet_name, string *vendor_ID);
                 ErrorMsg* CheckAdvertisedSpeed(string nic, INT32 speed);
                  string   Get_Node();
                 ErrorMsg* Append_Node(string bass_address);
        //virtual ERRORCODE Extrenal_loopback(string);          //Singal port
        //virtual ERRORCODE Extrenal_loopback(string, string);  //Dual port

    protected:

    private:
                //ERRORCODE Find_controller_BDF(string);

                ERRORCODE m_errorCode;
                //string    m_PCI_BFD;
                string    m_vendorID;
                string    m_deviceID;
                int       m_link_status;
                string    m_node;
                //string    m_controller_name;
               /*string controller_name;
               int    controller_ID;
               string led_name;
               string aliases;
               int    status;*/

};

#endif
