/*
 * GPIOGeneric.hpp
 *
 *  Created on: Dec 2, 2015
 *      Author: ianfang
 */

#ifndef GPIOGENERIC_HPP
#define GPIOGENERIC_HPP
#include "BaseClassDDAPI.hpp"
#include "CommonFunctions.hpp"
#include <list>
using namespace std;

#define FPGA_DATA_ELEMENT_NAME_LENGTH   20
#define PCH_DATA_ELEMENT_NAME_LENGTH   20
#define GPIO_DEVICE_NAME_LENGTH  30


#define GPIO_LIST_LENGTH	45
#define GPIO_SPACE_LENGTH	2

typedef enum
{
    FIRST=1,
    SECOND,
    THIRD,
    FOURTH,
    FIFTH,
    SIXTH,
    SEVENTH,
    EIGHTH,
}COLUMN_NUMBER;

enum GPIO_RW_MODE
{
    GPIO_READ_ONLY = 0,
    GPIO_WRITE_ONLY,
    GPIO_WRITE_CLEAR,
    GPIO_READ_WRITE,
    GPIO_NOT_SUPPORT,
};

enum FPGA_DRIVER_DATA_TYPE {
        GPIO_FPGA_DRIVER_DATA_TYPE_BOOLEAN = 0,
        GPIO_FPGA_DRIVER_DATA_TYPE_UINT8,
        GPIO_FPGA_DRIVER_DATA_TYPE_UINT16,
        GPIO_FPGA_DRIVER_DATA_TYPE_UINT32,
        GPIO_FPGA_DRIVER_DATA_TYPE_UNKNOWN,
};

enum PCH_DRIVER_DATA_TYPE {
        GPIO_PCH_DRIVER_DATA_TYPE_BOOLEAN = 0,
        GPIO_PCH_DRIVER_DATA_TYPE_UINT8,
        GPIO_PCH_DRIVER_DATA_TYPE_UINT16,
        GPIO_PCH_DRIVER_DATA_TYPE_UINT32,
        GPIO_PCH_DRIVER_DATA_TYPE_UNKNOWN,
};


class GPIOGeneric : public BaseClassDDAPI
{
    public:
            GPIOGeneric(STRING className);
            ~GPIOGeneric();

            virtual ErrorMsg*   readINIFile(CHAR *Line);
            virtual ErrorMsg*   getGPIOList(list<string> *pGPIOList);

            virtual ErrorMsg*   readBit(string gpioName, BOOL*  readValue);
            virtual ErrorMsg*   isMyGPIO(string    gpioName);
            virtual ErrorMsg*   writeBit(string  gpioName, BOOL Status);

//        virtual ERRORCODE AddEntry(STRING gpioName,
//                                   PHYSICAL_ADDRESS_T gpioAddress,
//                                   INT32 gpioBit,
//                                   BOOL gpioControl,
//                                   UINT32 misc
//                                   );
//        virtual ERRORCODE AddEntry(STRING gpioName,
//                                   UINT32 gpioIndex,
//                                   UINT32 bWritable
//                                   );
//        virtual ERRORCODE GetWellKnownNameByIndex(INT32 index, CHAR* gpioName, INT32 stringLength);
//        virtual ERRORCODE IsMyGPIO(STRING gpioName);
//        virtual ERRORCODE ReadBit(STRING gpioName, BOOL* readValue);
//        virtual ERRORCODE ResetBit(STRING gpioName);
//        virtual ERRORCODE SetBit(STRING gpioName);

    protected:

    private:



};





#endif /* GPIOGENERIC_HPP_ */
