#include "I2CDevice.hpp"



I2CDevice :: I2CDevice(string name, int bus, int device_address, I2C_DEVICE_TYPE device_type, string device_vender, string device_model)
{
    m_device_name = name;
    m_bus = bus;
    m_device_address = device_address;
    m_device_type = device_type;
    m_device_vender = device_vender;
    m_device_model = device_model;
    m_errorCode = NULL;
}



I2CDevice :: ~I2CDevice()
{

}



int I2CDevice :: IsSwitch()
{
    return 0;
}



int I2CDevice :: get_Bus()
{
    return m_bus;
}



int I2CDevice :: get_Address()
{
    return m_device_address;
}



char * I2CDevice :: get_Name()
{
    return (char*)m_device_name.c_str();
}



ErrorMsg * I2CDevice :: set_Master_bus(I2CBus *master_bus)
{
    m_master_bus = master_bus;

    return m_errorCode;
}



I2CBus * I2CDevice :: get_Master_bus()
{
    return m_master_bus;
}



ErrorMsg * I2CDevice :: set_Register_protocol(int index, I2C_DEVICE_PROTOCOL protocol)
{
    m_register_protocol[index] = protocol;

    return m_errorCode;
}



int I2CDevice :: get_Register_protocol(int index)
{
    return m_register_protocol[index];
}

I2C_DEVICE_TYPE I2CDevice :: get_type()
{
    return m_device_type;
}



string I2CDevice :: get_vender()
{
    return m_device_vender;
}



string I2CDevice :: get_model()
{
    return m_device_model;
}

