#include "PCICommonFunction.hpp"

#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <dirent.h>


//extern "C"{
//    #include <pci/pci.h>
//}


PCICommonFunction::PCICommonFunction()
{

}

PCICommonFunction::~PCICommonFunction()
{

}


#if 0
int 
sysfs_fill_info(struct pci_dev *d, int flags)
{
    if ((flags & PCI_FILL_PHYS_SLOT) && !(d->known_fields & PCI_FILL_PHYS_SLOT))
    {
        struct pci_dev *pd;
        sysfs_fill_slots(d->access);
        for (pd = d->access->devices; pd; pd = pd->next)
            pd->known_fields |= PCI_FILL_PHYS_SLOT;

    }

    if ((flags & PCI_FILL_MODULE_ALIAS) && !(d->known_fields & PCI_FILL_MODULE_ALIAS))
    {
        char buf[OBJBUFSIZE];
        if (sysfs_get_string(d, "modalias", buf, 0))
            d->module_alias = pci_strdup(d->access, buf);

    }

    return pci_generic_fill_info(d, flags);

}
#endif 

int 
PCICommonFunction::compare_them(const void *A, const void *B)
{
    const struct pci_dev *a = (*(const struct device **)A)->dev;
    const struct pci_dev *b = (*(const struct device **)B)->dev;

    if (a->domain < b->domain)
        return -1;
    if (a->domain > b->domain)
        return 1;
    if (a->bus < b->bus)
        return -1;
    if (a->bus > b->bus)
        return 1;
    if (a->dev < b->dev)
        return -1;
    if (a->dev > b->dev)
        return 1;
    if (a->func < b->func)
        return -1;
    if (a->func > b->func)
        return 1;

    return 0;
}


void 
PCICommonFunction::sort_them(struct device* out_first_dev)
{
    struct device **index, **h, **last_dev;
    int cnt;
    struct device *d;

    cnt = 0;
    for (d=out_first_dev; d; d=d->next)
    {
        cnt++;
    }
    printf("PCICommonFunction::sort_them, cnt: %d\n", cnt);//check 

    h = index = (struct device**)xmalloc(sizeof(struct device*) * cnt);
    for (d=out_first_dev; d; d=d->next)
    {
        *h++ = d;
    }
    qsort(index, cnt, sizeof(struct device *), compare_them);
    last_dev = &out_first_dev;
    h = index;
    while(cnt--)
    {
        printf("----------------------------###-----------------------------\n");//check 
        *last_dev = *h;
        last_dev = &(*h)->next;
        h++;
    }
    *last_dev = NULL;
    

    //check 
    printf("###########################################\n");
    while(out_first_dev)
    {
        printf("%04x:%02x:%02x.%x\n",
                out_first_dev->dev->domain, out_first_dev->dev->bus, out_first_dev->dev->dev,
                out_first_dev->dev->func);
        out_first_dev = out_first_dev->next;
    }
    printf("###########################################\n");
}


void
PCICommonFunction::sysfs_config(struct pci_access *a)
{
    //cout << "PCILibrary::sysfs_config" << endl;
  //pci_define_param(a, "sysfs.path", PCI_PATH_SYS_BUS_PCI, "Path to the sysfs device tree");
}


void
PCICommonFunction::sysfs_init(struct pci_access *a)
{
  a->fd = -1;
  a->fd_vpd = -1;
}

#if 0
void
pci_setup_cache(struct pci_dev *d, byte *cache, int len)
{
  d->cache = cache;
  d->cache_len = len;
}

int
config_fetch(struct device *d, unsigned int pos, unsigned int len)
{
  unsigned int end = pos+len;
  int result;

  while (pos < d->config_bufsize && len && d->present[pos])
    pos++, len--;
  while (pos+len <= d->config_bufsize && len && d->present[pos+len-1])
    len--;
  if (!len)
    return 1;

  if (end > d->config_bufsize)
    {
      int orig_size = d->config_bufsize;
      while (end > d->config_bufsize)
	d->config_bufsize *= 2;
      d->config = xrealloc(d->config, d->config_bufsize);
      d->present = xrealloc(d->present, d->config_bufsize);
      memset(d->present + orig_size, 0, d->config_bufsize - orig_size);
    }
  result = pci_read_block(d->dev, pos, d->config + pos, len);
  if (result)
    memset(d->present + pos, 1, len);
  return result;
}


int
pci_read_block(struct pci_dev *d, int pos, byte *buf, int len)
{
  return d->methods->read(d, pos, buf, len);
}

int
pci_filter_match(struct pci_filter *f, struct pci_dev *d)
{
  if ((f->domain >= 0 && f->domain != d->domain) ||
      (f->bus >= 0 && f->bus != d->bus) ||
      (f->slot >= 0 && f->slot != d->dev) ||
      (f->func >= 0 && f->func != d->func))
    return 0;
  if (f->device >= 0 || f->vendor >= 0)
    {
      pci_fill_info_v32(d, PCI_FILL_IDENT);
      if ((f->device >= 0 && f->device != d->device_id) ||
	  (f->vendor >= 0 && f->vendor != d->vendor_id))
	return 0;
    }
  return 1;
}

int 
pci_fill_info(struct pci_dev *d, int flags)
{
    if (flags & PCI_FILL_RESCAN)
    {
        flags &= ~PCI_FILL_RESCAN;
        d->known_fields = 0;
        pci_free_caps(d);

    }
    if (flags & ~d->known_fields)
        d->known_fields |= d->methods->fill_info(d, flags & ~d->known_fields);

    return d->known_fields;
}
#endif

void*
PCICommonFunction::xmalloc(unsigned int howmuch)
{
    void *p = malloc(howmuch);
    if (!p)
        printf("Unable to allocate %d bytes of memory", howmuch);
    return p;
}

struct bus *
PCICommonFunction::find_bus(struct bridge *b, unsigned int domain, unsigned int n)
{
    struct bus *bus;

    for (bus=b->first_bus; bus; bus=bus->sibling)
        if (bus->domain == domain && bus->number == n)
            break;
    return bus;
}

struct bus *
PCICommonFunction::new_bus(struct bridge *b, unsigned int domain, unsigned int n)
{
    struct bus *busInfo = (struct bus*)xmalloc(sizeof(struct bus));

    busInfo->domain = domain;
    busInfo->number = n;
    busInfo->sibling = b->first_bus;
    busInfo->first_dev = NULL;
    busInfo->last_dev = &busInfo->first_dev;
    b->first_bus = busInfo;
    return busInfo;
}

void
PCICommonFunction::insert_dev(struct device *d, struct bridge *b)
{
    struct pci_dev *p = d->dev;
    struct bus *bus;

    if (! (bus = find_bus(b, p->domain, p->bus)))
    {
        struct bridge *c;
        for (c=b->child; c; c=c->next)
            if (c->domain == p->domain && c->secondary <= p->bus && p->bus <= c->subordinate)
            {
                insert_dev(d, c);
                return;
            }
        bus = new_bus(b, p->domain, p->bus);
    }

    *bus->last_dev = d;
    bus->last_dev = &d->next;
    d->next = NULL;
}


void
PCICommonFunction::release_pci_tree(struct bridge*  host_bridge)
{
    struct bus    *bus_check;
    struct bridge *b_check;

    for(b_check = host_bridge; b_check; b_check = b_check->chain)
    {
        for(bus_check = b_check->first_bus; bus_check; bus_check = bus_check->sibling)
        {
            //release device structure
            if(bus_check->first_dev)
                release_device_struct(bus_check->first_dev);
        }
    }

    for(b_check = host_bridge; b_check; b_check = b_check->chain)
    {
        //release bus structure 
        if(b_check->first_bus)
            release_bus_struct(b_check->first_bus);
    }

    //release bridge structure 
    release_bridge_struct(host_bridge->chain);
}


void 
PCICommonFunction::release_bridge_struct(struct bridge *b)
{
    if(b->chain != NULL)
    {
        release_bridge_struct(b->chain);
    }

    free(b);
}


void 
PCICommonFunction::release_bus_struct(struct bus *bus_to_be_released)
{
    if(bus_to_be_released->sibling != NULL)
    {
        release_bus_struct(bus_to_be_released->sibling);
    }

    free(bus_to_be_released);
}


void 
PCICommonFunction::release_device_struct(struct device *d)
{
    //check
    //if(d->dev != NULL)
    //{
    //    printf("%04x:%02x:%02x.%x \n",
    //            d->dev->domain, d->dev->bus, d->dev->dev, d->dev->func);
    //}
    
    if(d->next != NULL)
    {
        release_device_struct(d->next);
    }

    //printf("AAAAAAAAAAAAAAAAAAAAAAAAAAAAAA\n");//check 

    if(d->config != NULL)
        free(d->config);
    
    //printf("QQQQQQQQQQQQQQQQQQQQQQQQQQQQQQ\n");//check 
    if(d->present != NULL)
        free(d->present);

    //printf("HHHHHHHHHHHHHHHHHHHHHHHHHHHHH\n");//check 
    free(d);

    //printf("FFFFFFFFFFFFFFFFFFFFFFFFFFFFFFFF\n");//check 
}

struct device*
PCICommonFunction::scan_device(struct pci_dev *p)
{
  struct device *d = (struct device*)malloc(sizeof(struct device));;

/*
  if (p->domain && !opt_domains)
    opt_domains = 1;
  if (!pci_filter_match(&filter, p))
    return NULL;
*/

  //d = (struct device*)malloc(sizeof(struct device));
  memset(d, 0, sizeof(*d));
  d->dev = p;

  d->config = NULL;
  d->present = NULL;
/*
  d->config_cached = d->config_bufsize = 64;
  d->config = xmalloc(64);
  d->present = xmalloc(64);
  memset(d->present, 1, 64);
  if (!pci_read_block(p, 0, d->config, 64))
    {
      fprintf(stderr, "lspci: Unable to read the standard configuration space header of device %04x:%02x:%02x.%d\n",
	      p->domain, p->bus, p->dev, p->func);
      seen_errors++;
      return NULL;
    }
  if ((d->config[PCI_HEADER_TYPE] & 0x7f) == PCI_HEADER_TYPE_CARDBUS)
    {
      // For cardbus bridges, we need to fetch 64 bytes more to get the
      // full standard header...
      if (config_fetch(d, 64, 64))
	d->config_cached += 64;
    }
  pci_setup_cache(p, d->config, d->config_cached);
  pci_fill_info(p, PCI_FILL_IDENT | PCI_FILL_CLASS | PCI_FILL_IRQ | PCI_FILL_BASES | PCI_FILL_ROM_BASE | PCI_FILL_SIZES | PCI_FILL_PHYS_SLOT);
*/

  return d;
}




void 
PCICommonFunction::sysfs_scan(struct pci_access *a)
{
    //char dirname[1024];
    DIR *dir;
    struct dirent *entry;
    //int n;

    //n = snprintf(dirname, sizeof(dirname), "%s/devices", sysfs_name(a));
    //if (n < 0 || n >= (int) sizeof(dirname))
    //  a->error("Directory name too long");
  
    //dir = opendir(dirname);
    dir = opendir(DIR_NAME);
    if (!dir)
    //  a->error("Cannot open %s", DIR_NAME);
        cout << "Cannot open " << DIR_NAME << endl;
  
    while ((entry = readdir(dir)))
    {
        struct pci_dev *d;
        unsigned int dom, bus, dev, func;

        /* ".", ".." or a special non-device perhaps */
        if (entry->d_name[0] == '.')
	        continue;

        //d = pci_alloc_dev(a);
        d = (struct pci_dev*)malloc(sizeof(struct pci_dev));
        memset(d, 0, sizeof(*d));
        if (sscanf(entry->d_name, "%x:%x:%x.%d", &dom, &bus, &dev, &func) < 4)
            cout << "sysfs_scan: Couldn't parse entry name " << entry->d_name << endl;
	        //a->error("sysfs_scan: Couldn't parse entry name %s", entry->d_name);
      
        d->domain = dom;
        d->bus = bus;
        d->dev = dev;
        d->func = func;

        //***
        d->vendor_id = ConfigReadWord(d->domain, d->bus, d->dev, d->func, 0x0);
        d->device_id = ConfigReadWord(d->domain, d->bus, d->dev, d->func, 0x2);

        /*
        if (!a->buscentric)
	    {
	        sysfs_get_resources(d);
	        d->irq = sysfs_get_value(d, "irq");
	           
            //We could read these faster from the config registers, but we want to give
	        //the kernel a chance to fix up ID's and especially classes of broken devices.
	        d->vendor_id = sysfs_get_value(d, "vendor");
	        d->device_id = sysfs_get_value(d, "device");
	        d->device_class = sysfs_get_value(d, "class") >> 8;
	        d->known_fields = PCI_FILL_IDENT | PCI_FILL_CLASS | PCI_FILL_IRQ | PCI_FILL_BASES | PCI_FILL_ROM_BASE | PCI_FILL_SIZES;
	    }
        */
        //pci_link_dev(a, d);
        d->next = a->devices;
        a->devices = d;
    }
    closedir(dir);
}

void 
PCICommonFunction::sysfs_cleanup_dev(struct pci_dev *d)
{
    //cout << "PCICommonFunction::sysfs_cleanup_dev" << endl;

    //struct pci_access *a = d->access;

    //if (a->cached_dev == d)
    //    sysfs_flush_cache(a);
}

void
PCICommonFunction::sysfs_flush_cache(struct pci_access *a)
{
    if (a->fd >= 0)
    {
        close(a->fd);
        a->fd = -1;
    }
    if (a->fd_vpd >= 0)
    {
        close(a->fd_vpd);
        a->fd_vpd = -1;
    }
    
    a->cached_dev = NULL;
}

void
PCICommonFunction::sysfs_cleanup(struct pci_access *a)
{
    sysfs_flush_cache(a);
}


struct pci_access *
PCICommonFunction::pci_alloc(void)
{
  struct pci_access *a = (struct pci_access*)malloc(sizeof(struct pci_access));
  //int i;

  memset(a, 0, sizeof(*a));
  /*
  pci_set_name_list_path(a, PCI_PATH_IDS_DIR "/" PCI_IDS, 0);
#ifdef PCI_USE_DNS
  pci_define_param(a, "net.domain", PCI_ID_DOMAIN, "DNS domain used for resolving of ID's");
  pci_define_param(a, "net.cache_name", "~/.pciids-cache", "Name of the ID cache file");
  a->id_lookup_mode = PCI_LOOKUP_CACHE;
#endif

  for (i=0; i<PCI_ACCESS_MAX; i++)
    if (pci_methods[i] && pci_methods[i]->config)
      pci_methods[i]->config(a);
*/
  
  sysfs_config(a);
  
  return a;
}


void
PCICommonFunction::pci_mfree(void *x)
{
    if(x)
    {
        free(x);
    }
}


void
PCICommonFunction::pci_free_caps(struct pci_dev *d)
{
    struct pci_cap *cap;
    while ((cap = d->first_cap))
    {
        d->first_cap = cap->next;
        pci_mfree(cap);
    }
}


void 
PCICommonFunction::pci_free_dev(struct pci_dev *d)
{
    sysfs_cleanup_dev(d);

    pci_free_caps(d);
    pci_mfree(d->module_alias);
    pci_mfree(d->phy_slot);
    pci_mfree(d);
}


void 
PCICommonFunction::pci_free_params(struct pci_access *acc)
{
    struct pci_param *p;

    while ((p = acc->params))
    {
        acc->params = p->next;
        
        if (p->value_malloced)
            pci_mfree(p->value);
        
        pci_mfree(p);
    }
}

void 
PCICommonFunction::pci_set_name_list_path(struct pci_access *a, char *name, int to_be_freed)
{
    if (a->free_id_name)
        free(a->id_file_name);

    a->id_file_name = name;
    a->free_id_name = to_be_freed;
}

void 
PCICommonFunction::pci_id_cache_flush(struct pci_access *a) 
{
    a->id_cache_status = 0;
}

void 
PCICommonFunction::pci_id_hash_free(struct pci_access *a)
{
    pci_mfree(a->id_hash);
    a->id_hash = NULL;

    while (a->current_id_bucket)
    {
        struct id_bucket *buck = a->current_id_bucket;
        a->current_id_bucket = buck->next;
        pci_mfree(buck);
    }
}

void 
PCICommonFunction::pci_free_name_list(struct pci_access *a)
{
    pci_id_cache_flush(a);
    pci_id_hash_free(a);
    a->id_load_failed = 0;
}

void
PCICommonFunction::pci_cleanup(struct pci_access *a)
{
    struct pci_dev *d, *e;

    for (d=a->devices; d; d=e)
    {
        e = d->next;
        pci_free_dev(d);
    }

    sysfs_cleanup(a);
    
    //if (a->methods)
    //    a->methods->cleanup(a);
  
    pci_free_name_list(a);
    pci_free_params(a);
    pci_set_name_list_path(a, NULL, 0);
    pci_mfree(a);
}


unsigned char
PCICommonFunction::ConfigReadByte(unsigned short in_u16Domain,
                                  unsigned short in_u16Bus,
                                  unsigned short in_u16Device,
                                  unsigned char  in_u8Function,
                                  unsigned int   in_u32Offset)
{
    int             fd;
    unsigned char   data = 0x0;
    char            namebuf[MAX_STRING_LENGTH];

    //unsigned int io_ret;
    //unsigned int deviceHandle;

    //cout << "PCIDevice::ConfigRead - byte" << endl; 

    snprintf(namebuf, MAX_STRING_LENGTH, "/sys/bus/pci/devices/%04x:%02x:%02x.%d/config",
             in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    fd = open(namebuf, O_RDONLY);

    pread(fd, &data, 1, in_u32Offset);

    close(fd);

    return data;


    //data = pci_read_byte(pDev, in_u32Offset);

    /*
    //device.domain   = m_u16Domain;
    device.bus      = m_u16Bus;
    device.dev      = m_u16Device;
    device.func     = m_u8Function;

    device.offset   = in_u32Offset;
    device.reserved = 0x0;
    data            = 0xff;

    deviceHandle = open(NODE_NAME, O_RDONLY);
    if(deviceHandle < 0)
    {
        data = 0xde;
        return data;
    }
    io_ret = ioctl(deviceHandle, READ_PCI_CONFIG_BYTE, &device); //include file <sys/ioctl.h>
    if(io_ret == 0)
    {
        data = device.reserved;
    }

    close(deviceHandle);
    return data;
    */

}


unsigned short
PCICommonFunction::ConfigReadWord(unsigned short in_u16Domain,
                                  unsigned short in_u16Bus,
                                  unsigned short in_u16Device,
                                  unsigned char  in_u8Function,
                                  unsigned int   in_u32Offset)
{
    int                 fd;
    unsigned short      data = 0x0;
    char                namebuf[MAX_STRING_LENGTH];


    snprintf(namebuf, MAX_STRING_LENGTH, "/sys/bus/pci/devices/%04x:%02x:%02x.%d/config",
             in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    fd = open(namebuf, O_RDONLY);

    pread(fd, &data, 2, in_u32Offset);

    close(fd);

    return data;
}

    
unsigned int
PCICommonFunction::ConfigReadDword(unsigned short in_u16Domain,
                                   unsigned short in_u16Bus,
                                   unsigned short in_u16Device,
                                   unsigned char  in_u8Function,
                                   unsigned int   in_u32Offset)
{
    int             fd;
    unsigned int    data = 0x0;
    char            namebuf[MAX_STRING_LENGTH];


    snprintf(namebuf, MAX_STRING_LENGTH, "/sys/bus/pci/devices/%04x:%02x:%02x.%d/config",
             in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    fd = open(namebuf, O_RDONLY);

    pread(fd, &data, 4, in_u32Offset);

    close(fd);

    return data;
}


int 
PCICommonFunction::ConfigWriteByte(unsigned short  in_u16Domain,
                                   unsigned short  in_u16Bus,
                                   unsigned short  in_u16Device,
                                   unsigned char   in_u8Function,
                                   unsigned int    in_u32Offset,
                                   unsigned char   in_u8WriteData)
{
    int   fd;
    int   ret = 0;
    char  namebuf[MAX_STRING_LENGTH];

    snprintf(namebuf,64,"/sys/bus/pci/devices/%04x:%02x:%02x.%x/config",
            in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    //printf("namebuf ------ %s\n",namebuf);//check

    fd = open(namebuf,O_RDWR);
    if(fd < 0)
    {
        printf("cannot open %s\n",namebuf);
        ret = -1;
    }
    else 
    {
        ret = pwrite(fd, &in_u8WriteData, 1, in_u32Offset);
        if(ret < 0)
        {
            printf("write failed\n");
            ret = -1;
        }
    }

    close(fd);
    return ret;    
}


int 
PCICommonFunction::ConfigWriteWord(unsigned short  in_u16Domain,
                                   unsigned short  in_u16Bus,
                                   unsigned short  in_u16Device,
                                   unsigned char   in_u8Function,
                                   unsigned int    in_u32Offset,
                                   unsigned short  in_u16WriteData)
{
    int   fd;
    int   ret = 0;
    char  namebuf[MAX_STRING_LENGTH];

    snprintf(namebuf,64,"/sys/bus/pci/devices/%04x:%02x:%02x.%x/config",
            in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    fd = open(namebuf,O_RDWR);
    if(fd < 0)
    {
        printf("cannot open %s\n",namebuf);
        ret = -1;
    }
    else 
    {
        ret = pwrite(fd, &in_u16WriteData, 2, in_u32Offset);
        if(ret < 0)
        {
            printf("write failed\n");
            ret = -1;
        }
    }

    close(fd);
    return ret;    
}


int 
PCICommonFunction::ConfigWriteDword(unsigned short  in_u16Domain,
                                    unsigned short  in_u16Bus,
                                    unsigned short  in_u16Device,
                                    unsigned char   in_u8Function,
                                    unsigned int    in_u32Offset,
                                    unsigned int    in_u32WriteData)
{
    int   fd;
    int   ret = 0;
    char  namebuf[MAX_STRING_LENGTH];

    snprintf(namebuf,64,"/sys/bus/pci/devices/%04x:%02x:%02x.%x/config",
            in_u16Domain, in_u16Bus, in_u16Device, in_u8Function);

    //printf("namebuf ------ %s\n",namebuf);//check

    fd = open(namebuf,O_RDWR);
    if(fd < 0)
    {
        printf("cannot open %s\n",namebuf);
        ret = -1;
    }
    else 
    {
        ret = pwrite(fd, &in_u32WriteData, 4, in_u32Offset);
        if(ret < 0)
        {
            printf("write failed\n");
            ret = -1;
        }
    }

    close(fd);
    return ret;    
}


void 
PCICommonFunction::GetCapList(unsigned short in_u16Domain,
                              unsigned short in_u16Bus,
                              unsigned short in_u16Device,
                              unsigned char  in_u8Function,
                              list<CapInfo> *pCapInfo)
{
    unsigned int    temp;
    unsigned int    tempCapID;
    unsigned int    tempCapOffset;
    unsigned int    tempNextCapOffset;

    list<CapInfo>::iterator it;


    //cout << "PCIDevice::GetCapList" << endl;
 
    if(m_u8CapPtrValue != 0x0)
    {
        tempCapOffset = (unsigned int)m_u8CapPtrValue;
        //temp = ConfigReadDword((unsigned int)m_u8CapPtrValue);
        temp = ConfigReadDword(in_u16Domain, in_u16Bus, in_u16Device, in_u8Function, tempCapOffset);
        tempCapID = temp & 0xff;
        tempNextCapOffset = (temp & 0xff00) >> 8;
        //printf("tempNextCapOffset: 0x%x\n", tempNextCapOffset);//check 
        
        while(tempNextCapOffset != 0x0)
        {
            CapInfo tempCapInfo(tempCapID, tempCapOffset, tempNextCapOffset);
            tempCapOffset = tempNextCapOffset;
            pCapInfo->push_back(tempCapInfo);
            //m_listCap.push_back(tempCapInfo);

            temp = ConfigReadDword(in_u16Domain, in_u16Bus, in_u16Device, in_u8Function, tempNextCapOffset);
            tempCapID = temp & 0xff;
            tempNextCapOffset = (temp & 0xff00) >> 8;
        }

        CapInfo tempCapInfo(tempCapID, tempCapOffset, tempNextCapOffset);
        pCapInfo->push_back(tempCapInfo);
        //m_listCap.push_back(tempCapInfo);
    }

    /*
    //check 
    //for(it = m_listCap.begin(); it != m_listCap.end(); ++it)
    for(it = pCapInfo->begin(); it != pCapInfo->end(); ++it)
    {
        printf("CapID: 0x%02x  CapOffset: 0x%02x NextCapOffset:0x%02x\n",
                (unsigned short)it->GetCapID(), (unsigned short)it->GetCapOffset(), (unsigned short)it->GetNextCapOffset());
    }
    */
}


/*
unsigned short
PCICommonFunction::ConfigReadWord(struct pci_dev *pDev, unsigned int in_u32Offset)
{
    unsigned short data = 0x0;
    //cout << "PCIDevice::ConfigRead - word" << endl;
    data = pci_read_word(pDev, in_u32Offset);
    return data;
}


unsigned int 
PCICommonFunction::ConfigReadDword(struct pci_dev *pDev, unsigned int in_u32Offset)
{
    unsigned int data = 0x0;
    //cout << "PCIDevice::ConfigRead - Dword" << endl;
    data = pci_read_long(pDev, in_u32Offset);
    return data;
}
*/







